
public class SimpleThreads {

	// Display a message, preceded by
	// the name of the current thread
	static void threadMessage(String message) {
		String threadName = Thread.currentThread().getName();
		System.out.format("%s: %s%n",threadName,message);
	}

	private static class MessageLoop implements Runnable {
		public void run() {
			String importantInfo[] = {
					"Nel giorno pi splendente, nella notte pi profonda",
					"nessun malvagio sfugga alla mia ronda",
					"colui che nel male si perde si guardi dal mio potere,",
					"la luce di Lanterna Verde! "
			};
			try {
				for (int i = 0;i < importantInfo.length;i++) {
					Thread.sleep(4000);
					threadMessage(importantInfo[i]);
				}
			} catch (InterruptedException e) {
				threadMessage("I wasn't done!");
			}
		}
	}

	public static void main(String args[])
			throws InterruptedException {
		
		long patience = 1000 * 60 * 60;

		threadMessage("MessaggeLoop inizia");
		long startTime = System.currentTimeMillis();
		Thread t = new Thread(new MessageLoop());
		t.start();

		threadMessage("Attendo che MessaggeLoop finisca");
		while (t.isAlive()) {
			threadMessage("Aspetto...");
			t.join(1000);
			if (((System.currentTimeMillis() - startTime) > patience)
					&& t.isAlive()) {
				threadMessage("Stanco di aspettarre!");
				t.interrupt();
				t.join();
			}
		}
		threadMessage("Finito!");
	}
}
